# welco - multichannel request processing
# Copyright (C) 2015  Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django import template
from django.contrib.contenttypes.models import ContentType
from django.template import RequestContext

from .models import PhoneCall

class Home(object):
    source_key = 'phone'

    def __init__(self, request):
        self.request = request

    def render(self):
        context = RequestContext(self.request)
        context['source_type'] = ContentType.objects.get_for_model(PhoneCall)
        tmpl = template.loader.get_template('welco/phone_home.html')
        return tmpl.render(context)
